'*******************************************************************************
'************************* ATMEGA32  DS18B20 ********************************
'*******************************************************************************
'--------------------     ---------------------
 $regfile = "m32def.dat" : $crystal = 8000000 : $framesize = 120 : $hwstack = 120 : $swstack = 120 : $baud = 9600
'-------------------------------------------------------------------------------
 Config Lcdpin = Pin , Rs = Portb.0 , E = Portb.1 , Db4 = Portc.2 , Db5 = Portc.3 , Db6 = Portc.4 , Db7 = Portc.5
 Config Lcd = 20 * 4 : Initlcd : Cursor Off Noblink : Cls
'-------------------------------------------------------------------------------
'-------------------------- _------------------------------
'-------------------------------------------------------------------------------
 Deflcdchar 0 , 2 , 5 , 5 , 5 , 2 , 32 , 32 , 32            '  , 
 Deflcdchar 1 , 28 , 20 , 28 , 32 , 32 , 32 , 32 , 32       ' 
 Deflcdchar 2 , 14 , 10 , 10 , 10 , 14 , 31 , 31 , 14       '
 Deflcdchar 3 , 6 , 9 , 9 , 6 , 32 , 32 , 32 , 32           ' 
'  Deflcdchar 3 , 31 , 27 , 19 , 27 , 27 , 27 , 17 , 31        ' 1
'  Deflcdchar 4 , 31 , 17 , 21 , 29 , 27 , 23 , 17 , 31        ' 2
'  Deflcdchar 5 , 31 , 17 , 29 , 25 , 29 , 29 , 17 , 31        ' 3
'  Deflcdchar 6 , 31 , 23 , 21 , 21 , 17 , 29 , 29 , 31        ' 4
'  Deflcdchar 7 , 4 , 5 , 15 , 20 , 4 , 14 , 10 , 27           '
'  Deflcdchar 4 , 232 , 244 , 232 , 227 , 228 , 228 , 227 , 224       ' 
'-------------------------------------------------------------------------------
'-----------------------  DS18B20 ----------------------------------
'-------------------------------------------------------------------------------
 Config 1wire = Portb.4 : Ds18b20 Alias Pinb.4
'-------------------------------------------------------------------------------
'**************************   ***********************************

 Dim 1_id_ds18b20(8) As Byte
 Dim 2_id_ds18b20(8) As Byte
 Dim 3_id_ds18b20(8) As Byte
 Dim 4_id_ds18b20(8) As Byte
 Dim 5_id_ds18b20(8) As Byte
 Dim 6_id_ds18b20(8) As Byte
 Dim 7_id_ds18b20(8) As Byte
 Dim 8_id_ds18b20(8) As Byte
 Dim 9_id_ds18b20(8) As Byte
 Dim 10_id_ds18b20(8) As Byte
 Dim 11_id_ds18b20(8) As Byte
 Dim 12_id_ds18b20(8) As Byte
 Dim 13_id_ds18b20(8) As Byte
 Dim 14_id_ds18b20(8) As Byte
 Dim 15_id_ds18b20(8) As Byte
 Dim 16_id_ds18b20(8) As Byte
 Dim 17_id_ds18b20(8) As Byte
 Dim 18_id_ds18b20(8) As Byte
 Dim 19_id_ds18b20(8) As Byte
 Dim 20_id_ds18b20(8) As Byte
 Dim 21_id_ds18b20(8) As Byte
 Dim 22_id_ds18b20(8) As Byte
 Dim 23_id_ds18b20(8) As Byte
 Dim 24_id_ds18b20(8) As Byte
 Dim 25_id_ds18b20(8) As Byte
 Dim 26_id_ds18b20(8) As Byte
 Dim 27_id_ds18b20(8) As Byte
 Dim 28_id_ds18b20(8) As Byte
 Dim 29_id_ds18b20(8) As Byte
 Dim 30_id_ds18b20(8) As Byte
 Dim 31_id_ds18b20(8) As Byte
 Dim 32_id_ds18b20(8) As Byte
 Dim 33_id_ds18b20(8) As Byte
 Dim 34_id_ds18b20(8) As Byte
 Dim 35_id_ds18b20(8) As Byte
 Dim 36_id_ds18b20(8) As Byte
 Dim 37_id_ds18b20(8) As Byte
 Dim 38_id_ds18b20(8) As Byte
 Dim 39_id_ds18b20(8) As Byte
 Dim 40_id_ds18b20(8) As Byte
 Dim 41_id_ds18b20(8) As Byte
 Dim 42_id_ds18b20(8) As Byte
 Dim 43_id_ds18b20(8) As Byte
 Dim 44_id_ds18b20(8) As Byte
 Dim 45_id_ds18b20(8) As Byte
 Dim 46_id_ds18b20(8) As Byte
 Dim 47_id_ds18b20(8) As Byte
 Dim 48_id_ds18b20(8) As Byte
 Dim 49_id_ds18b20(8) As Byte
 Dim 50_id_ds18b20(8) As Byte
 Dim 51_id_ds18b20(8) As Byte
 Dim 52_id_ds18b20(8) As Byte
 Dim 53_id_ds18b20(8) As Byte
 Dim 54_id_ds18b20(8) As Byte
 Dim 55_id_ds18b20(8) As Byte
 Dim 56_id_ds18b20(8) As Byte
 Dim 57_id_ds18b20(8) As Byte
 Dim 58_id_ds18b20(8) As Byte
 Dim 59_id_ds18b20(8) As Byte
 Dim 60_id_ds18b20(8) As Byte
'-------------------------------------------------------------------------------
 Dim Adres_id_ds18b20 As Word

 Declare Sub Displey_lcd()
 Declare Sub Opros_id_ds18b20()

 Declare Function Zapros_kolichestva_ds18b20() As Integer   '    Ds18b20  
 Dim Kolichestvo_ds18b20 As Integer                         'Word/Integer       

 Declare Sub Save_eeprom_id_ds18b20()
 Dim Id_ds18b20(8) As Byte

 Declare Sub Reading_eeprom_id_ds18b20()
'*******************************************************************************
 Do
'-------
    'Toggle Led_norma : Waitms 300
    'Pulselednorma = 30 Then : Toggle Led_norma : Pulselednorma = 0 : End If

    rcall Zapros_kolichestva_ds18b20

    rcall Save_eeprom_id_ds18b20

    rcall Reading_eeprom_id_ds18b20

    'rcall Opros_id_ds18b20

'-------
 Loop
'*******************************************************************************

'*******************************************************************************
'-------------------------------------------------------------------------------
 Function Zapros_kolichestva_ds18b20() As Integer
'---------------------------------------------------
 Local A As Byte
'-----------------
    For A = 1 To 3                                          '  ,  LCD 3 
      Cls                                                   ' LCD
        'Waitms 100
'=============================================
          Kolichestvo_ds18b20 = 1wirecount()                '   Ds18b20  
'=============================================
        Locate 1 , 1 : Lcd "    It is found     "           '  LCD ""
        Locate 2 , 1 : Lcd " " ; Kolichestvo_ds18b20 ; " sensors DS18B20"       '      
      Waitms 1000                                           ' ~ 750ms
    Next                                                    '
      Wait 1                                                ' ~ 2s
      Print Kolichestvo_ds18b20 ;                           '     Ds18b20  
    Print : Cls
'---------------
  End Function
'-------------------------------------------------------------------------------
'*******************************************************************************

'*******************************************************************************
'*********     ID DS18B20  EEPROM  ********
'*******************************************************************************
'-------------------------------------------------------------------------------
  Sub Save_eeprom_id_ds18b20                                '    ID DS18B20  EEPROM 
'---------------------------
  Local A As Byte , B As Byte , C As Byte                   '  ,      
'--------------------------------------------
'=========   ==========
  Id_ds18b20(1) = 1wsearchfirst()                           '       8-    
'==================================
      A = 1

      Print "     " ; A ; " Ds18b20"
      Print "   Write EEPROM    "
      Print "ID " ;

      Upperline                                             'Upperline  1 , Lowerline  2 , Thirdline  3 , Fourthline 4 
      Lcd "    " ; A ; " Ds18b20"
      Thirdline                                             'Upperline  1 , Lowerline  2 , Thirdline  3 , Fourthline 4 
      Lcd "   Write EEPROM    "
      Lowerline                                             'Upperline  1 , Lowerline  2 , Thirdline  3 , Fourthline 4 
      Lcd "ID "                                             '  LCD, "ID"

    Adres_id_ds18b20 = 10                                   '  10  (   (  - 10 ,   - 20   .. ))
      For B = 1 To 8                                        '  8  ,  ID DS18B20
        Print Hex(id_ds18b20(b)) ;                          '  , ,  8 
        Lcd Hex(id_ds18b20(b))                              '  LCD, ,  8 
          Writeeeprom Id_ds18b20(b) , Adres_id_ds18b20      '      
         Waitms 5                                           ' ~ 5ms
        Incr Adres_id_ds18b20                               '   1
      Next B                                                '     ID   
     Waitms 250                                             ' ~ 500ms

    Print : Print "       READY" : Print                    '     
    Fourthline                                              'Upperline  1 , Lowerline  2 , Thirdline  3 , Fourthline 4 
    Lcd "       READY"                                      '  LCD ""
   'Waitms 500                                                   ' ~ 1s
  'Cls                                                       ' LCD
'-------    --------
  For A = 2 To Kolichestvo_ds18b20
'===================================
    Id_ds18b20(1) = 1wsearchnext()                          '       8-    
'===================================
      Adres_id_ds18b20 = Adres_id_ds18b20 + 2               '   2, -  ,  ( )

      Print "     " ; A ; " Ds18b20"
      Print "   Write EEPROM    "
      Print "ID " ;

      Upperline                                             'Upperline  1 , Lowerline  2 , Thirdline  3 , Fourthline 4 
      Lcd "    " ; A ; " Ds18b20"
      Thirdline                                             'Upperline  1 , Lowerline  2 , Thirdline  3 , Fourthline 4 
      Lcd "   Write EEPROM    "
      Lowerline                                             'Upperline  1 , Lowerline  2 , Thirdline  3 , Fourthline 4 
      Lcd "ID "                                             '  LCD, "ID"

        For B = 1 To 8                                      '  8  ,  ID DS18B20
          Lcd Hex(id_ds18b20(b))                            '  LCD, ,  8 
          Print Hex(id_ds18b20(b)) ;                        '  , ,  8 
          Writeeeprom Id_ds18b20(b) , Adres_id_ds18b20      '      
            Waitms 5                                        ' ~ 5ms
          Incr Adres_id_ds18b20                             '   1
        Next B                                              '     ID  
      Waitms 250                                            ' ~ 500ms

    Print : Print "       READY " : Print                   '     
    Fourthline                                              'Upperline  1 , Lowerline  2 , Thirdline  3 , Fourthline 4 
    Lcd "       READY "                                     '  LCD ""
      Waitms 250                                            ' ~ 1s
    'Cls                                                     ' LCD
  Next A                                                    '    

'-------------------------------------------------------------------------------
'  LCD    ,  ,     EEPROM, ID  Ds18b20
'Id Sensors Ds18b20 Read And Written In The Eeprom
'id      EEPROM
'-------------------------------------------------------------------------------
    For A = 1 To 5                                          '  ,  LCD 3 
      Cls                                                   ' LCD
        Waitms 500
          Upperline                                         'Upperline  1 , Lowerline  2 , Thirdline  3 , Fourthline 4 
          Lcd " id sensors Ds18b20 "
          Lowerline
          Lcd "       read         "
          Thirdline
          Lcd "    and written     "
          Fourthline
          Lcd "   in the EEPROM    "
      Waitms 750                                            ' ~ 750ms
    Next                                                    '
          Print " id sensors Ds18b20 "
          Print "       read         "
          Print "    and written     "
          Print "   in the EEPROM    "
          Print
       Wait 5
'----------
  End Sub                                                   '      ID DS18B20  EEPROM 
'-------------------------------------------------------------------------------
'*******************************************************************************

'*******************************************************************************
'*********   ID DS18B20  EEPROM  ****************
'*******************************************************************************
'-------------------------------------------------------------------------------
  Sub Reading_eeprom_id_ds18b20
'------------------------------
  Local A As Byte , B As Byte
'-------------------------------
  Adres_id_ds18b20 = 10
'-----------------------
  Cls
    For A = 1 To Kolichestvo_ds18b20

      Print "     " ; A ; " Ds18b20"
      Print "Read from the EEPROM"
      Print "ID " ;

      Upperline                                             'Upperline  1 , Lowerline  2 , Thirdline  3 , Fourthline 4 
      Lcd "    " ; A ; " Ds18b20"
      Lowerline                                             'Upperline  1 , Lowerline  2 , Thirdline  3 , Fourthline 4 
      Lcd "Read from the EEPROM"
      Thirdline                                             'Upperline  1 , Lowerline  2 , Thirdline  3 , Fourthline 4 
      Lcd "ID ";                                            '  LCD, "ID"

      For B = 1 To 8

        Readeeprom Id_ds18b20(b) , Adres_id_ds18b20

          Lcd Hex(id_ds18b20(b))                            '  LCD, ,  8 
          Print Hex(id_ds18b20(b)) ;                        '  , ,  8 

          Select Case Adres_id_ds18b20
            Case 10 To 19 : 1_id_ds18b20(b) = Id_ds18b20(b)
            Case 20 To 29 : 2_id_ds18b20(b) = Id_ds18b20(b)
            Case 30 To 39 : 3_id_ds18b20(b) = Id_ds18b20(b)
            Case 40 To 49 : 4_id_ds18b20(b) = Id_ds18b20(b)
            Case 50 To 59 : 5_id_ds18b20(b) = Id_ds18b20(b)
            Case 60 To 69 : 6_id_ds18b20(b) = Id_ds18b20(b)
            Case 70 To 79 : 7_id_ds18b20(b) = Id_ds18b20(b)
            Case 80 To 89 : 8_id_ds18b20(b) = Id_ds18b20(b)
            Case 90 To 99 : 9_id_ds18b20(b) = Id_ds18b20(b)
            Case 100 To 109 : 10_id_ds18b20(b) = Id_ds18b20(b)
            Case 110 To 119 : 11_id_ds18b20(b) = Id_ds18b20(b)
            Case 120 To 129 : 12_id_ds18b20(b) = Id_ds18b20(b)
            Case 130 To 139 : 13_id_ds18b20(b) = Id_ds18b20(b)
            Case 140 To 149 : 14_id_ds18b20(b) = Id_ds18b20(b)
            Case 150 To 159 : 15_id_ds18b20(b) = Id_ds18b20(b)
            Case 160 To 169 : 16_id_ds18b20(b) = Id_ds18b20(b)
            Case 170 To 179 : 17_id_ds18b20(b) = Id_ds18b20(b)
            Case 180 To 189 : 18_id_ds18b20(b) = Id_ds18b20(b)
            Case 190 To 199 : 19_id_ds18b20(b) = Id_ds18b20(b)
            Case 200 To 209 : 20_id_ds18b20(b) = Id_ds18b20(b)
            Case 210 To 219 : 21_id_ds18b20(b) = Id_ds18b20(b)
            Case 220 To 229 : 22_id_ds18b20(b) = Id_ds18b20(b)
            Case 230 To 239 : 23_id_ds18b20(b) = Id_ds18b20(b)
            Case 240 To 249 : 24_id_ds18b20(b) = Id_ds18b20(b)
            Case 250 To 259 : 25_id_ds18b20(b) = Id_ds18b20(b)
            Case 260 To 269 : 26_id_ds18b20(b) = Id_ds18b20(b)
            Case 270 To 279 : 27_id_ds18b20(b) = Id_ds18b20(b)
            Case 280 To 289 : 28_id_ds18b20(b) = Id_ds18b20(b)
            Case 290 To 299 : 29_id_ds18b20(b) = Id_ds18b20(b)
            Case 300 To 309 : 30_id_ds18b20(b) = Id_ds18b20(b)
            Case 310 To 319 : 31_id_ds18b20(b) = Id_ds18b20(b)
            Case 320 To 329 : 32_id_ds18b20(b) = Id_ds18b20(b)
            Case 330 To 339 : 33_id_ds18b20(b) = Id_ds18b20(b)
            Case 340 To 349 : 34_id_ds18b20(b) = Id_ds18b20(b)
            Case 350 To 359 : 35_id_ds18b20(b) = Id_ds18b20(b)
            Case 360 To 369 : 36_id_ds18b20(b) = Id_ds18b20(b)
            Case 370 To 379 : 37_id_ds18b20(b) = Id_ds18b20(b)
            Case 380 To 389 : 38_id_ds18b20(b) = Id_ds18b20(b)
            Case 390 To 399 : 39_id_ds18b20(b) = Id_ds18b20(b)
            Case 400 To 409 : 40_id_ds18b20(b) = Id_ds18b20(b)
            Case 410 To 419 : 41_id_ds18b20(b) = Id_ds18b20(b)
            Case 420 To 429 : 42_id_ds18b20(b) = Id_ds18b20(b)
            Case 430 To 439 : 43_id_ds18b20(b) = Id_ds18b20(b)
            Case 440 To 449 : 44_id_ds18b20(b) = Id_ds18b20(b)
            Case 450 To 459 : 45_id_ds18b20(b) = Id_ds18b20(b)
            Case 460 To 469 : 46_id_ds18b20(b) = Id_ds18b20(b)
            Case 470 To 479 : 47_id_ds18b20(b) = Id_ds18b20(b)
            Case 480 To 489 : 48_id_ds18b20(b) = Id_ds18b20(b)
            Case 490 To 499 : 49_id_ds18b20(b) = Id_ds18b20(b)
            Case 500 To 509 : 50_id_ds18b20(b) = Id_ds18b20(b)
            Case 510 To 519 : 51_id_ds18b20(b) = Id_ds18b20(b)
            Case 520 To 529 : 52_id_ds18b20(b) = Id_ds18b20(b)
            Case 530 To 539 : 53_id_ds18b20(b) = Id_ds18b20(b)
            Case 540 To 549 : 54_id_ds18b20(b) = Id_ds18b20(b)
            Case 550 To 559 : 55_id_ds18b20(b) = Id_ds18b20(b)
            Case 560 To 569 : 56_id_ds18b20(b) = Id_ds18b20(b)
            Case 570 To 579 : 57_id_ds18b20(b) = Id_ds18b20(b)
            Case 580 To 589 : 58_id_ds18b20(b) = Id_ds18b20(b)
            Case 590 To 599 : 59_id_ds18b20(b) = Id_ds18b20(b)
            Case 600 To 609 : 60_id_ds18b20(b) = Id_ds18b20(b)
            Case Else
          End Select

           Incr Adres_id_ds18b20
         Next B
       Adres_id_ds18b20 = Adres_id_ds18b20 + 2
      Waitms 250                                            ' ~ 500ms

      Print : Print "       READY " : Print                 '     
      Fourthline                                            'Upperline  1 , Lowerline  2 , Thirdline  3 , Fourthline 4 
      Lcd "       READY "                                   '  LCD ""
        Waitms 250                                          ' ~ 500ms
      'Cls
    Next A
'-------------------------------------------------------------------------------
'  LCD    ,     EEPROM c      , ID  Ds18b20
'id sensors Ds18b20 EEPROM read from and written to the RAM of the microcontroller
'id  Ds18b20       R 
'-------------------------------------------------------------------------------
    For A = 1 To 5                                          '  ,  LCD 3 
      Cls                                                   ' LCD
        Waitms 500
          Upperline                                         'Upperline  1 , Lowerline  2 , Thirdline  3 , Fourthline 4 
          Lcd " ID sensors Ds18b20 "
          Lowerline
          Lcd "EEPROM read from and"
          Thirdline
          Lcd " written to the RAM "
          Fourthline
          Lcd " of the controller! "
      Waitms 750                                            ' ~ 750ms
    Next                                                    '
          Print " ID sensors Ds18b20 "
          Print "EEPROM read from and"
          Print " written to the RAM "
          Print " of the controller! "
       Wait 5
'----------
  End Sub                                                   '      ID DS18B20  EEPROM 
'-------------------------------------------------------------------------------
'*******************************************************************************
'*******************************************************************************
  Sub Displey_lcd():
'-------------------------------

'-------------------------------
  End Sub
'*******************************************************************************

 End